routes/admin.php
<?php

use App\Http\Controllers\Admin\DashboardController;
use App\Http\Controllers\Admin\ProfileController;
use App\Http\Controllers\Admin\UserController;
use App\Http\Controllers\Admin\RoleController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Admin Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web,verified,is_admin" middleware group and "admin." name.
| Now create something great!
|
*/

Route::get('dashboard', [DashboardController::class,'index'])->name('dashboard');

Route::resource('users', UserController::class);

Route::post('add-roles/{role}',[RoleController::class,'addRolesToAdmins']);
Route::resource('roles', RoleController::class);

Route::resource('profile', ProfileController::class)->parameters([
    'profile' => 'user'
])->only(['show','edit','update'])->middleware('me');

routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Route::get('/dashboard', function () {
    return view('dashboard');
})->middleware(['auth'])->name('dashboard');

require __DIR__.'/auth.php';

app/Models/User.php
<?php

namespace App\Models;

use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;
use Laravel\Sanctum\HasApiTokens;
use Illuminate\Database\Eloquent\Relations\BelongsToMany;


class User extends Authenticatable
{
    use HasApiTokens, HasFactory, Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var string[]
     */
    protected $fillable = [
        'name',
        'email',
        'password',
        'photo',
        'level',
    ];

    /**
     * The attributes that should be hidden for serialization.
     *
     * @var array
     */
    protected $hidden = [
        'password',
        'remember_token',
        'level',
    ];

    /**
     * The attributes that should be cast.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];

    public function scopeFilter($query,Array $request)
    {
        $request = collect($request);

        if($request->get('search'))
            $query->where('name','like','%'.$request->get('search').'%')->orWhere('email','like','%'.$request->get('search').'%');

        return $query;
    }

    public function roles(): BelongsToMany
    {
        return $this->belongsToMany(Role::class);
    }

    public function hasRoles(array $roles)
    {
        foreach($roles as $role)
        {
            if($this->roles->contains('title',$role['title']))
            {
                return true;
            }
        }

        return false;
    }

    public function hasPermission(String $title)
    {
        $permission = Permission::where('title',$title)->first();

        if(!$permission) return null;

        $roles = $permission->roles;

        if(!$roles) return false;

        return $this->hasRoles($roles->toArray());
    }
}

app/Http/Controllers/Admin/UserController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Models\User;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Storage;
use Illuminate\Validation\Rules;

class UserController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Request $request)
    {
        $this->authorize('viewAny',User::class);

        $users = User::filter(['search' => $request->search])->latest()->paginate(12)->withQueryString();
        return view('admin.users.index',compact('users'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $this->authorize('create',User::class);

        return view('admin.users.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $this->authorize('create',User::class);

        $request->validate([
            "email" => "required|string|email|max:255|unique:users",
            "name" => "required|string|max:255",
            "password" => ['required', 'confirmed', Rules\Password::defaults()],
            "level" => "required|in:user,admin",
            "photo" => "nullable|image"
        ]);

        $photo = $request->file('photo');
        $photo = $photo ? $photo->store('users/profile','public') : null;

        User::create([
            "email"     => $request->input('email'),
            "name"      => $request->input('name'),
            "password"  => Hash::make($request->password),
            "level"     => $request->input('level'),
            "photo"     => $photo,
        ]);

        return back()->with('success', 'کاربر با موفقیت ایجاد شد.');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\User  $user
     * @return \Illuminate\Http\Response
     */
    public function show(User $user)
    {
        return view('admin.users.show',compact('user'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\User  $user
     * @return \Illuminate\Http\Response
     */
    public function edit(User $user)
    {
        $this->authorize('update',User::class);

        return view('admin.users.edit',compact('user'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\User  $user
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, User $user)
    {
        $this->authorize('update',User::class);

        $request->validate([
            "email" => "required|string|email|max:255",
            "name" => "required|string|max:255",
            "level" => "required|in:user,admin",
            "photo" => "nullable|image"
        ]);

        $photo = $request->file('photo');

        if($photo)
        {
            if($user->photo) Storage::disk('public')->delete($user->photo);

            $user->photo = $photo->store('users/profile','public');
            $user->save();
        }


        $user->update([
            "email"     => $request->input('email'),
            "name"      => $request->input('name'),
            "level"     => $request->input('level'),
        ]);


        return back()->with('success', 'کاربر با موفقیت ویرایش شد.');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\User  $user
     * @return \Illuminate\Http\Response
     */
    public function destroy(User $user)
    {
        $this->authorize('delete',User::class);

        if($user->photo) Storage::disk('public')->delete($user->photo);
        $user->delete();

        return back();
    }
}

resources/views/admin/users/create.blade.php
<x-admin.layouts>

    <div class="row">
        <div class="col-md-12">
            <div class="card stacked-form">
                <div class="card-header ">
                    <h4 class="card-title">افزودن کاربر جدید</h4>
                </div>
                <div class="card-body ">
                    <form method="POST" action="{{ route('admin.users.store') }}" enctype="multipart/form-data">
                        @csrf
                        <div class="form-row">
                            <div class="form-group col-md-6 @error('name') has-error @enderror">
                                <label>نام</label>
                                <input type="text" name="name" class="form-control" value="{{ old('name') }}">
                                @error('name')
                                    <label class="error" for="name">{{ $message }}</label>
                                @enderror
                            </div>
                            <div class="form-group col-md-6 @error('email') has-error @enderror">
                                <label>ایمیل</label>
                                <input type="email" name="email" class="form-control" value="{{ old('email') }}">
                                @error('email')
                                    <label class="error" for="name">{{ $message }}</label>
                                @enderror
                            </div>
                        </div>

                        <div class="form-row">
                            <div class="form-group col-md-6 @error('password') has-error @enderror">
                                <label>رمز عبور</label>
                                <input type="password" name="password" class="form-control">
                                @error('password')
                                    <label class="error" for="name">{{ $message }}</label>
                                @enderror
                            </div>
                            <div class="form-group col-md-6">
                                <label>تکرار رمز عبور</label>
                                <input type="password" name="password_confirmation" class="form-control">

                            </div>
                        </div>

                        <div class="form-row">
                            <div class="form-group col-md-6">
                                <label>سطح</label>
                                <select class="custom-select" name="level">
                                    <option value="user" selected>عادی</option>
                                    <option value="admin">ادمین</option>
                                </select>
                            </div>
                            <div class="form-group col-md-6 @error('photo') has-error @enderror">
                                <label>عکس پروفایل</label>
                                <input type="file" name="photo" class="form-control">
                                @error('photo')
                                    <label class="error" for="name">{{ $message }}</label>
                                @enderror
                            </div>
                        </div>

                        <div class="form-group">
                            <button type="submit" class="btn btn-fill btn-info">ثبت</button>
                        </div>
                    </form>
                </div>

            </div>
        </div>
        @push('scripts')
            @if (session()->has('success'))
            <script>
                swal("پیام موفقیت!", "{{ session('success') }}", "success")
            </script>
            @endif
        @endpush

    </div>
</x-admin.layouts>

resources/views/admin/users/edit.blade.php
<x-admin.layouts>

    <div class="row">
        <div class="col-md-12">
            <div class="card stacked-form">
                <div class="card-header d-flex justify-content-start align-items-center">
                    <img src="{{ $user->photo ? asset('storage/' . $user->photo) : asset('profile.png') }}"  height="64" width="64" class="rounded-circle mx-2" alt="">
                    <h4 class="card-title">ویرایش کاربر {{ $user->name }}</h4>
                </div>
                <div class="card-body ">
                    <form method="POST" action="{{ route('admin.users.update',$user) }}" enctype="multipart/form-data">
                        @csrf
                        @method('patch')
                        <div class="form-row">
                            <div class="form-group col-md-6 @error('name') has-error @enderror">
                                <label>نام</label>
                                <input type="text" name="name" class="form-control" value="{{ $user->name }}">
                                @error('name')
                                    <label class="error" for="name">{{ $message }}</label>
                                @enderror
                            </div>
                            <div class="form-group col-md-6 @error('email') has-error @enderror">
                                <label>ایمیل</label>
                                <input type="email" name="email" class="form-control" value="{{ $user->email }}">
                                @error('email')
                                    <label class="error" for="name">{{ $message }}</label>
                                @enderror
                            </div>
                        </div>


                        <div class="form-row">
                            <div class="form-group col-md-6">
                                <label>سطح</label>
                                <select class="custom-select" name="level">
                                    <option value="user" {{ $user->level === 'user' ? 'selected' : '' }}>عادی</option>
                                    <option value="admin" {{ $user->level === 'admin' ? 'selected' : '' }}>ادمین</option>
                                </select>
                            </div>
                            <div class="form-group col-md-6 @error('photo') has-error @enderror">
                                <label>عکس پروفایل</label>
                                <input type="file" name="photo" class="form-control">
                                @error('photo')
                                    <label class="error" for="name">{{ $message }}</label>
                                @enderror
                            </div>
                        </div>

                        <div class="form-group">
                            <button type="submit" class="btn btn-fill btn-info">ثبت</button>
                        </div>
                    </form>
                </div>

            </div>
        </div>
        @push('scripts')
            @if (session()->has('success'))
            <script>
                swal("پیام موفقیت!", "{{ session('success') }}", "success")
            </script>
            @endif
        @endpush
    </div>
</x-admin.layouts>

resources/views/admin/users/index.blade.php
<x-admin.layouts>
    <div class="row">
        <div class="col-md-6">
            <h4 class="card-title">لیست کاربران</h4>
        </div>
    </div>
    <div class="row">
        <div class="col-md-12">
            <div class="card table-with-switches">
                <div class="card-header ">
                    <div class="d-flex justify-content-between align-items-center">
                        <div>
                            @can('create',App\Models\User::class)
                            <a class="btn btn-info" href="{{ route('admin.users.create') }}">افزودن کاربر جدید</a>
                            @endcan
                        </div>
                        <div>
                            <form action="{{ route('admin.users.index') }}" method="get" class="position-relative">
                                <input type="name" value="{{ request('search') }}" name="search" class="form-control form-control-sm" placeholder="جستجو...">
                                @if (request('search'))
                                <a href="{{ route('admin.users.index') }}" style="position: absolute;top: 8px;left: 10px;">x</a>
                                @endif
                            </form>
                        </div>
                    </div>
                </div>
                <div class="card-body table-full-width">
                    @if ($users->isEmpty())
                        <div class="col">
                            <div class="alert alert-info" role="alert">
                                موردی برای نمایش وجود ندارد.
                            </div>
                        </div>
                    @else
                    <table class="table table-striped">

                        <thead>
                            <tr>
                                <th>نام</th>
                                <th>ایمیل</th>
                                <th class="text-center">سطح</th>
                                @canany(['delete','update'],App\Models\User::class)
                                <th class="text-center"></th>
                                @endcanany
                            </tr>
                        </thead>
                        <tbody>
                            @foreach ($users as $user)
                            <tr>
                                <td class="d-flex justify-content-start align-items-center align-middle">
                                    <div><img height="32" width="32" class="rounded-circle" src="{{ $user->photo ? asset('storage/' .$user->photo) : asset('profile.png') }}" alt=""></div>
                                    <div class="mx-2">
                                        <a href="{{ route('admin.users.show',$user) }}">
                                            {{ $user->name }}
                                        </a>
                                    </div>
                                </td>
                                <td>{{ $user->email }}</td>
                                <td class="text-center">
                                    @if ($user->level === 'user')
                                        <span class="badge p-2 badge-info">عادی</span>
                                    @else
                                        <span class="badge p-2 badge-success">ادمین</span>
                                    @endif
                                </td>
                                <td class="text-right">
                                    <form action="{{route('admin.users.destroy',$user->id)}}" method="post">
                                        @csrf
                                        @method('delete')
                                        @can('update',App\Models\User::class)
                                        <a href="{{ route('admin.users.edit',$user->id) }}" class="btn btn-primary btn-sm">ویرایش<i class="icon-pencil"></i></a>
                                        @endcan
                                        @can('delete',App\Models\User::class)
                                        <button class="btn btn-danger btn-sm" id="delete-item-{{ $user->id }}" ><i class="icon-trash-o "></i>حذف</button>
                                        @push('scripts')
                                            <script>
                                                $("#delete-item-{{ $user->id }}").on('click', function (event) {
                                                    event.preventDefault();
                                                    var self = $(this);
                                                    swal({
                                                        title: "مطمئنی؟",
                                                        text: "",
                                                        type: "warning",
                                                        showCancelButton: true,
                                                        confirmButtonClass: "btn btn-info btn-fill",
                                                        confirmButtonText: "آره",
                                                        cancelButtonText: "انصراف",
                                                        cancelButtonClass: "btn btn-danger btn-fill",
                                                        closeOnConfirm: false,
                                                    }, function() {
                                                        self.parents('form:first').submit();
                                                        swal("موفق!", "با موفقیت حذف شد.", "success");
                                                    });
                                                });
                                            </script>
                                        @endpush
                                        @endcan
                                    </form>
                                </td>
                            </tr>
                            @endforeach
                        </tbody>
                    </table>

                    <div class="d-flex justify-content-center align-items-center">
                        {{ $users->links() }}
                    </div>
                    @endif
                </div>
            </div>
        </div>

    </div>
</x-admin.layouts>

resources/views/admin/users/show.blade.php
<x-admin.layouts>

    <div class="row">
        <div class="col-lg-6">
            <div class="card stacked-form">
                <div class="card-title">
                    <div class="card-header d-flex justify-content-start align-items-center">
                        <img src="{{ $user->photo ? asset('storage/' . $user->photo) : asset('profile.png') }}"  height="64" width="64" class="rounded-circle mx-2" alt="">
                        <h4>پروفایل کاربر {{ $user->name }}</h4>
                    </div>
                </div>
                <div class="card-body">
                    <table class="table table-hover">
                        <thead>
                            <tr>
                                <th></th>
                                <th></th>
                            </tr>
                        </thead>
                        <tbody>
                            <tr>
                                <td style="width: 100px;">نام</td>
                                <td>{{ $user->name }}</td>
                            </tr>
                            <tr>
                                <td style="width: 100px;">ایمیل</td>
                                <td>{{ $user->email }}</td>
                            </tr>
                            <tr>
                                <td style="width: 100px;">سطح</td>
                                <td>{{ $user->level === 'admin' ? 'ادمین' : 'عادی' }}</td>
                            </tr>
                            @if ($user->level === 'admin')
                            <tr>
                                <td style="width: 100px;"> نقش ها</td>
                                <td>
                                    @if ($user->roles->isEmpty())
                                        -
                                    @else
                                    @foreach ($user->roles as $role)
                                    <span class="badge m-1 p-2 badge-info ">{{ $role->fa_title }} ({{ $role->title }})</span>
                                    @endforeach
                                    @endif
                                </td>
                            </tr>
                            @endif
                        </tbody>
                    </table>
                </div>

            </div>
        </div>
    </div>
</x-admin.layouts>